<template>
  <div id="chart" class="chart"></div>
</template>

<style>
  .d3-tooltip {
    position: absolute;
  }
  .chart {
    text-align: center
  }
</style>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator'
import * as d3 from 'd3'

const NULL_FRAMEWORK_NAME = 'No Framework'
const NULL_FRAMEWORK_COLOR = '#EEEEEE'

@Component
export default class AuditChart extends Vue {
  @Prop({ default: {} })
  data!: any[]

  @Prop()
  frameworks!: any

  @Prop()
  topLevelGroup!: any

  @Watch('data')
  onDataChanged (): void {
    this.mounted()
  }

  get chartData (): any {
    return [['Framework', 'Projects']].concat(this.frameworkAdoptionSummary)
  }

  get frameworkAdoptionSummary (): any {
    const totals: any = {}
    this.data.map((project: any) => {
      const frameworkName = project.hasComplianceFramework ? project.complianceFramework.name : NULL_FRAMEWORK_NAME
      // eslint-disable-next-line security/detect-object-injection
      if (totals[frameworkName]) {
        // eslint-disable-next-line security/detect-object-injection
        totals[frameworkName]++
      } else {
        // eslint-disable-next-line security/detect-object-injection
        totals[frameworkName] = 1
      }
    })

    return totals
  }

  get colors (): any {
    const domain: string[] = []
    const range: string[] = []
    const mapped: any = {}

    Object.keys(this.frameworkAdoptionSummary).forEach((name: string) => {
      // eslint-disable-next-line security/detect-object-injection
      const color = name === NULL_FRAMEWORK_NAME ? NULL_FRAMEWORK_COLOR : this.frameworks[name].color
      domain.push(name)
      range.push(color)
      // eslint-disable-next-line security/detect-object-injection
      mapped[name] = color
    })

    return { domain, range, mapped }
  }

  makeResponsive (svg: any): void {
    // Container is the DOM element, svg is appended.
    // Then we measure the container and find its
    // aspect ratio.
    const container = d3.select(svg.node().parentNode)
    const width = parseInt(svg.style('width'), 10)
    const height = parseInt(svg.style('height'), 10)
    const aspect = width / height

    // Add viewBox attribute to set the value to initial size
    // add preserveAspectRatio attribute to specify how to scale
    // and call resize so that svg resizes on page load
    svg.attr('viewBox', `0 0 ${width} ${height}`)
      .attr('preserveAspectRatio', 'xMinYMid')
      .call(resize)

    d3.select(window).on('resize.' + container.attr('id'), resize)

    function resize () {
      const targetWidth = parseInt(container.style('width'))
      svg.attr('width', targetWidth)
      svg.attr('height', Math.round(targetWidth / aspect))
    }
  }

  mounted (): void {
    // create a tooltip
    let tooltip = d3.select('body').select('.v-application').select('#d3-tooltip')
    if (tooltip.nodes().length === 0) {
      tooltip = d3.select('body')
        .select('.v-application')
        .append('div')
        .attr('id', 'd3-tooltip')
        .attr('class', 'd3-tooltip text-subtitle-2 grey darken-3 white--text')
    }
    tooltip.style('opacity', 0)
      .style('border', 'solid')
      .style('border-width', '1px')
      .style('border-radius', '3px')
      .style('padding', '5px')

    // See: https://d3-graph-gallery.com/graph/donut_label.html
    // set the dimensions and margins of the graph
    const width = 1000
    const height = 300
    const margin = 20

    // The radius of the pieplot is half the width or half the height (smallest one). I subtract a bit of margin.
    const radius = Math.min(width, height) / 2 - margin

    // append the svg object to the div called 'my_dataviz'
    const svg = d3.select('#chart')
      .append('svg')
      .attr('width', width)
      .attr('height', height)
      .call(this.makeResponsive) // Call responsivefy to make the chart responsive
      .append('g')
      .attr('transform', `translate(${width / 2},${height / 2})`)

    // Compute the position of each group on the pie:
    const pie = d3.pie()
      .sort(null)
      .value((d: any) => d[1])

    const dataReady = pie(Object.entries(this.frameworkAdoptionSummary))

    // Donut arc
    const arc = d3.arc()
      .innerRadius(radius * 0.35) // This is the size of the donut hole
      .outerRadius(radius * 0.8)

    // Label positioning
    const outerArc = d3.arc()
      .innerRadius(radius * 0.9)
      .outerRadius(radius * 0.9)

    // Build the pie chart: Basically, each part of the pie is a path that we build using the arc function.
    svg
      .selectAll('allSlices')
      .data(dataReady)
      .join('path')
      .attr('d', arc)
      .attr('fill', (d: any) => {
        return this.colors.mapped[d.data[0]]
      })
      .attr('stroke', 'none')
      .style('stroke-width', '1px')
      .style('opacity', 0.8)
      .on('mouseover', function (this: any) {
        tooltip.style('opacity', 1)
        d3.select(this)
          // .style('stroke', 'grey')
          // .style('stroke-width', '1px')
          .style('opacity', 1)
      })
      .on('mousemove', (event: any, d:any) => {
        const frameworkPercentage = ((d.value / this.data.length) * 100).toFixed()
        tooltip
          .html(`Projects: ${d.value} (${frameworkPercentage}%)`)
          .style('left', (event.pageX + 5) + 'px')
          .style('top', (event.pageY + 5) + 'px')
      })
      .on('mouseleave', function (this: any) {
        tooltip.style('opacity', 0)
        d3.select(this)
          .style('stroke', 'none')
          .style('opacity', 0.8)
      })

    // Add the polylines between chart and labels:
    svg
      .selectAll('allPolylines')
      .data(dataReady)
      .join('polyline')
      .attr('stroke', 'black')
      .style('fill', 'none')
      .attr('stroke-width', 1)
      .attr('points', (d: any) => {
        const posA = arc.centroid(d) // line insertion in the slice
        const posB = outerArc.centroid(d) // line break: we use the other arc generator that has been built only for that
        const posC = outerArc.centroid(d) // Label position = almost the same as posB
        const midangle = d.startAngle + (d.endAngle - d.startAngle) / 2 // we need the angle to see if the X position will be at the extreme right or extreme left
        posC[0] = radius * 0.95 * (midangle < Math.PI ? 1 : -1) // multiply by 1 or -1 to put it on the right or on the left
        return [posA, posB, posC]
      })

    // Add the polylines between chart and labels:
    svg
      .selectAll('allLabels')
      .data(dataReady)
      .join('text')
      .text((d: any) => d.data[0])
      .attr('transform', (d: any) => {
        const pos = outerArc.centroid(d)
        const midangle = d.startAngle + (d.endAngle - d.startAngle) / 2
        pos[0] = radius * 0.99 * (midangle < Math.PI ? 1 : -1)
        pos[1] = pos[1] + 5
        return `translate(${pos})`
      })
      .style('text-anchor', (d: any) => {
        const midangle = d.startAngle + (d.endAngle - d.startAngle) / 2
        return (midangle < Math.PI ? 'start' : 'end')
      })
  }
}
</script>
